﻿using MySql.Data.MySqlClient;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MxFilterGen2.Generator
{
    internal class Daggers
    {
        private static string iBint = "";
        private static string iBstr = "";
        private static string iBdex = "";

        public static void Gen()
        {
            using (MySqlConnection connection = DB.MySql.MSQLCo())
            {
                try
                {
                    connection.Open();

                    string query = "SELECT * FROM item_base";
                    using (MySqlCommand command = new MySqlCommand(query, connection))
                    {
                        using (MySqlDataReader reader = command.ExecuteReader())
                        {
                            while (reader.Read())
                            {
                                string name = reader.GetString("name");

                                if (reader.GetString("class") == "Dagger")
                                {
                                    iBdex += string.Format(@" ""{0}""", name);
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    Console.WriteLine($"Error: {ex.Message}");
                }
            }

            string path = "out/gen/DAGGERS.filter";
            File.AppendAllText(path, $"#### SECTION: (Daggers)" + Environment.NewLine, Encoding.UTF8);

            // normal
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"## RARITY:   Normal" + Environment.NewLine, Encoding.UTF8);
            if (iBint != ""){
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"# TYPE:      INT" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBint + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Normal" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorNormal + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorInt + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBstr != ""){
            File.AppendAllText(path, $"# TYPE:      STR" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBstr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Normal" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorNormal + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorStr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBdex != ""){
            File.AppendAllText(path, $"# TYPE:      DEX" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBdex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Normal" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorNormal + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorDex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }


            // magic
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"## RARITY:   Magic" + Environment.NewLine, Encoding.UTF8);
            if (iBint != ""){
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"# TYPE:      INT" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBint + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Magic" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorMagic + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorInt + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBstr != ""){
            File.AppendAllText(path, $"# TYPE:      STR" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBstr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Magic" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorMagic + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorStr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBdex != ""){
            File.AppendAllText(path, $"# TYPE:      DEX" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBdex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Magic" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorMagic + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorDex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }


            // rare
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"## RARITY:   Rare" + Environment.NewLine, Encoding.UTF8);
            if (iBint != ""){
            File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            File.AppendAllText(path, $"# TYPE:      INT" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBint + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorRare + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorInt + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBstr != ""){
            File.AppendAllText(path, $"# TYPE:      STR" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBstr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorRare + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorStr + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }

            if (iBdex != ""){
            File.AppendAllText(path, $"# TYPE:      DEX" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    BaseType " + iBdex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    Rarity = Rare" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.TextColorRare + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetBackgroundColor 54 54 54" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, _Color.BorderColorDex + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    SetFontSize 35" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(path, "    CustomAlertSound \"mx_tier.mp3\"" + Environment.NewLine, Encoding.UTF8);
                File.AppendAllText(path, Environment.NewLine ?? "", Encoding.UTF8);
            }
        }
    }
}
